 #>
 #include <gtk/gtk.h>
 #include <gdk/gdk.h>
 <#
 
 ;; Parse declarations and generate Scheme bindings:

 #>?
 /* We just need a declaration, so this is sufficient: */
 const int GTK_WINDOW_TOPLEVEL;
 const int G_TYPE_STRING;

 void gtk_main_quit();
 void gtk_init(int *, char ***);
 void gtk_window_set_title(GtkWindow *window, char *);
 void gtk_window_set_default_size(GtkWindow *window, int width, int height);
 void gtk_window_move(GtkWindow *window, int x, int y);

  int g_signal_connect(void *, char *, void *, void *);

 GtkWidget *gtk_window_new(int);
 GtkWidget *gtk_vbox_new(bool homogeneous, int spacing);
 GtkWidget *gtk_image_new_from_file(char *filename);
 GtkWidget *gtk_toolbar_new(void);
 GtkToolItem *gtk_tool_button_new(GtkWidget *icon, char *label);
 
 void gtk_widget_show(GtkWidget *);
 void gtk_box_pack_start(GtkBox *box, GtkWidget *child, bool expand, bool fill, int padding);
 void gtk_toolbar_insert(GtkToolbar *toolbar, GtkToolItem *item, int pos);
 void gtk_container_add(GtkContainer *container, GtkWidget *widget);
 void gtk_widget_set_size_request(GtkWidget *widget, int width, int height);

   /* the ___callback marker is needed, because gtk_main() may
   (and will) call Scheme callbacks. */
 ___callback void gtk_main();
 <#
  
   
(define add-tool-button
  (lambda (toolbar icon pos)
    (let
      ((source (sprintf "~A.png" icon))
       (icon #f)
       (button #f))
       
      (set! icon (gtk_image_new_from_file source))
      (set! button (gtk_tool_button_new icon #f))
      
      (gtk_toolbar_insert toolbar button pos)
      (gtk_widget_show icon)
      (gtk_widget_show button)
      #t)))
      
                  
(define create-toolbar
  (lambda ()
    (let 
      ((tbar (gtk_toolbar_new)))
            
      (add-tool-button tbar "newfile"  0)
      (add-tool-button tbar "openfile" 1)

      (gtk_widget_show tbar)
    
      tbar)))


;; Define a window callback functions:

 (define-external (delete_event ((pointer "GtkWidget") widget)
				((pointer "GdkEvent") event)
				(c-pointer data) )
   bool (print "closing")
   #f)

 (define-external (destroy ((pointer "GtkWidget") widget)
			   (c-pointer data) )
   void (gtk_main_quit))

 ;; Start of program
 
 (foreign-code "gtk_init(&C_main_argc, &C_main_argv);")

 (define window (gtk_window_new GTK_WINDOW_TOPLEVEL))
 
 (g_signal_connect window "delete_event" #$delete_event #f)
 (g_signal_connect window "destroy" #$destroy #f)

 (define mainpane (gtk_vbox_new #f 2))
 (gtk_widget_set_size_request mainpane 200 200)
 
 (define toolbar (create-toolbar))
  
 (gtk_box_pack_start mainpane toolbar #f #t 0)
 (gtk_container_add window mainpane)
 (gtk_widget_show mainpane)

 (gtk_widget_show window)
 (gtk_main)
